package com.example.aped.ui.all_IOs;

import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.List;

public class MainListViewAdapter extends BaseAdapter {

    private MainActivity mainActivity;

    private int image;

    private int favoriteImage;

    public MainListViewAdapter(MainActivity pMainActivity){
        this.mainActivity = pMainActivity;
    }


    @Override
    public int getCount() {
        return mainActivity.xml.getDeviceNames().size();
    }

    @Override
    public Object getItem(final int position) {

        return null;
    }

    @Override
    public long getItemId(final int position) {

        return 0;
    }

    @Override
    public View getView(final int i, View view,
                        final ViewGroup viewGroup) {
        view = mainActivity.getLayoutInflater().inflate(R.layout.listview_layout,
                null);
        ImageView imageView = (ImageView) view.findViewById(
                R.id.images);
        TextView textViewName = (TextView) view.findViewById(
                R.id.textName);
        TextView textViewPin = (TextView) view.findViewById(
                R.id.textPin);
        ImageView buttonViewFavoriten = (ImageView) view.findViewById(
                R.id.imageButtonFavoriten);
        mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().
                get(i), new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(final JSONObject response) {
                try {
                    String firstpinvalue = response.getJSONObject("state").getString(((List<String>) (mainActivity.xml.getPort(mainActivity.xml.getDeviceNames().get(i))).get("pins")).get(0));
                    if(firstpinvalue.equals("1")) {
                        image=R.drawable.green_signal;
                    }else if (firstpinvalue.equals("0")) {
                        image = R.drawable.red_signal;
                    } else{ image = R.drawable.off_signal; }
                    imageView.setImageResource(image);
                } catch (JSONException e) {
                    e.printStackTrace();
                    image = R.drawable.off_signal;
                    imageView.setImageResource(image);
                }

            }
        });

        if (mainActivity.favorite.getFavorites().contains(
                mainActivity.xml.getDeviceNames().get(i))) {
            favoriteImage = android.R.drawable.btn_star_big_on;
        } else {
            favoriteImage = android.R.drawable.btn_star_big_off;
        }

        buttonViewFavoriten.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(final View view) {
                        if (mainActivity.favorite.getFavorites().contains(
                                mainActivity.xml.getDeviceNames().get(i))) {
                            mainActivity.favorite.removeFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_off;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        } else {
                            mainActivity.favorite.addFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_on;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        }
                    }
                });
        textViewPin.setText(((List<String>) (mainActivity.xml.getPort(mainActivity.xml.getDeviceNames().get(i))).get("pins")).get(0));
        textViewName.setText(mainActivity.xml.getDeviceNames().get(i));
        buttonViewFavoriten.setImageResource(favoriteImage);
        return view;
    }
}
